Index: uspace/lib/c/test/stdio/scanf.c
===================================================================
--- uspace/lib/c/test/stdio/scanf.c	(revision ed18e148046bfdc424427e6fcc350b1718b2628b)
+++ uspace/lib/c/test/stdio/scanf.c	(revision 5a6c28d195eff93f3ee378bd1f116b66a4c0fd9c)
@@ -55,5 +55,5 @@
 
 	/* Empty format string */
-	rc = xxsscanf("42", "");
+	rc = sscanf("42", "");
 	PCUT_ASSERT_INT_EQUALS(0, rc);
 }
@@ -65,5 +65,5 @@
 
 	/* Decimal integer */
-	rc = xxsscanf("42", "%d", &i);
+	rc = sscanf("42", "%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -76,5 +76,5 @@
 
 	/* Two integers */
-	rc = xxsscanf("42 43", "%d%d", &i, &j);
+	rc = sscanf("42 43", "%d%d", &i, &j);
 	PCUT_ASSERT_INT_EQUALS(2, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -88,5 +88,5 @@
 
 	/* Decimal signed char */
-	rc = xxsscanf("42", "%hhd", &sc);
+	rc = sscanf("42", "%hhd", &sc);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(sc == 42);
@@ -99,5 +99,5 @@
 
 	/* Decimal short */
-	rc = xxsscanf("42", "%hd", &si);
+	rc = sscanf("42", "%hd", &si);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(si == 42);
@@ -110,5 +110,5 @@
 
 	/* Decimal long */
-	rc = xxsscanf("42", "%ld", &li);
+	rc = sscanf("42", "%ld", &li);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(li == 42);
@@ -121,5 +121,5 @@
 
 	/* Decimal long long */
-	rc = xxsscanf("42", "%lld", &lli);
+	rc = sscanf("42", "%lld", &lli);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(lli == 42);
@@ -132,5 +132,5 @@
 
 	/* Decimal intmax_t */
-	rc = xxsscanf("42", "%jd", &imax);
+	rc = sscanf("42", "%jd", &imax);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(imax == 42);
@@ -143,5 +143,5 @@
 
 	/* Decimal size_t-sized */
-	rc = xxsscanf("42", "%zd", &szi);
+	rc = sscanf("42", "%zd", &szi);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(szi == 42);
@@ -154,5 +154,5 @@
 
 	/* Decimal ptrdiff_t-sized */
-	rc = xxsscanf("42", "%td", &pdi);
+	rc = sscanf("42", "%td", &pdi);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(pdi == 42);
@@ -165,5 +165,5 @@
 
 	/* Decimal integer followed by hexadecimal digit */
-	rc = xxsscanf("42a", "%d", &i);
+	rc = sscanf("42a", "%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -176,5 +176,5 @@
 
 	/* Decimal integer - detect no prefix */
-	rc = xxsscanf("42", "%i", &i);
+	rc = sscanf("42", "%i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -187,5 +187,5 @@
 
 	/* Prefixed octal integer followed by decimal digit */
-	rc = xxsscanf("019", "%i", &i);
+	rc = sscanf("019", "%i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 1);
@@ -198,5 +198,5 @@
 
 	/* Prefixed hexadecimal integer followed by other character */
-	rc = xxsscanf("0xag", "%i", &i);
+	rc = sscanf("0xag", "%i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 10);
@@ -209,5 +209,5 @@
 
 	/* Decimal integer with '+' sign */
-	rc = xxsscanf("+42", "%d", &i);
+	rc = sscanf("+42", "%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -220,5 +220,5 @@
 
 	/* Decimal integer with '-' sign */
-	rc = xxsscanf("-42", "%d", &i);
+	rc = sscanf("-42", "%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == -42);
@@ -231,5 +231,5 @@
 
 	/* Hexadecimal integer with prefix and '-' sign */
-	rc = xxsscanf("-0xa", "%i", &i);
+	rc = sscanf("-0xa", "%i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == -10);
@@ -242,5 +242,5 @@
 
 	/* Decimal unsigned integer */
-	rc = xxsscanf("42", "%u", &u);
+	rc = sscanf("42", "%u", &u);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(u == 42);
@@ -253,5 +253,5 @@
 
 	/* Decimal unsigned char */
-	rc = xxsscanf("42", "%hhu", &uc);
+	rc = sscanf("42", "%hhu", &uc);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(uc == 42);
@@ -264,5 +264,5 @@
 
 	/* Decimal unsigned short */
-	rc = xxsscanf("42", "%hu", &su);
+	rc = sscanf("42", "%hu", &su);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(su == 42);
@@ -275,5 +275,5 @@
 
 	/* Decimal unsigned long */
-	rc = xxsscanf("42", "%lu", &lu);
+	rc = sscanf("42", "%lu", &lu);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(lu == 42);
@@ -286,5 +286,5 @@
 
 	/* Decimal unsigned long long */
-	rc = xxsscanf("42", "%llu", &llu);
+	rc = sscanf("42", "%llu", &llu);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(llu == 42);
@@ -297,5 +297,5 @@
 
 	/* Decimal uintmax_t */
-	rc = xxsscanf("42", "%ju", &umax);
+	rc = sscanf("42", "%ju", &umax);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(umax == 42);
@@ -308,5 +308,5 @@
 
 	/* Decimal size_t */
-	rc = xxsscanf("42", "%zu", &szu);
+	rc = sscanf("42", "%zu", &szu);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(szu == 42);
@@ -319,5 +319,5 @@
 
 	/* Decimal ptrdiff_t-sized unsigned int*/
-	rc = xxsscanf("42", "%tu", &pdu);
+	rc = sscanf("42", "%tu", &pdu);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(pdu == 42);
@@ -330,5 +330,5 @@
 
 	/* Octal unsigned integer */
-	rc = xxsscanf("52", "%o", &u);
+	rc = sscanf("52", "%o", &u);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(u == 052);
@@ -341,5 +341,5 @@
 
 	/* Hexadecimal unsigned integer */
-	rc = xxsscanf("2a", "%x", &u);
+	rc = sscanf("2a", "%x", &u);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(u == 0x2a);
@@ -352,5 +352,5 @@
 
 	/* Hexadecimal unsigned integer unsing alternate specifier */
-	rc = xxsscanf("2a", "%X", &u);
+	rc = sscanf("2a", "%X", &u);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(u == 0x2a);
@@ -363,9 +363,21 @@
 
 	/* Uppercase hexadecimal unsigned integer */
-	rc = xxsscanf("2A", "%x", &u);
+	rc = sscanf("2A", "%x", &u);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(u == 0x2a);
 }
 
+PCUT_TEST(hex_not_match_0x)
+{
+	int rc;
+	unsigned u;
+
+	/* Make sure %x does not match 0x prefix */
+	rc = sscanf("0x1", "%x", &u);
+
+	PCUT_ASSERT_INT_EQUALS(1, rc);
+	PCUT_ASSERT_TRUE(u == 0);
+}
+
 PCUT_TEST(skipws)
 {
@@ -374,5 +386,5 @@
 
 	/* Skipping whitespace */
-	rc = xxsscanf(" \t\n42", "%d", &i);
+	rc = sscanf(" \t\n42", "%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -385,5 +397,5 @@
 
 	/* Percentile conversion */
-	rc = xxsscanf(" \t\n%42", "%%%d", &i);
+	rc = sscanf(" \t\n%42", "%%%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -396,5 +408,5 @@
 
 	/* Matching specific character */
-	rc = xxsscanf("x42", "x%d", &i);
+	rc = sscanf("x42", "x%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -407,5 +419,5 @@
 
 	/* Matching specific character should not skip whitespace */
-	rc = xxsscanf(" x42", "x%d", &i);
+	rc = sscanf(" x42", "x%d", &i);
 	PCUT_ASSERT_INT_EQUALS(0, rc);
 }
@@ -417,5 +429,5 @@
 
 	/* Skipping whitespace + match specific character */
-	rc = xxsscanf(" x42", "\t\nx%d", &i);
+	rc = sscanf(" x42", "\t\nx%d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -428,5 +440,5 @@
 
 	/* Decimal with limited, but sufficient width */
-	rc = xxsscanf("42", "%2d", &i);
+	rc = sscanf("42", "%2d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 42);
@@ -439,5 +451,5 @@
 
 	/* Decimal with limited, smaller width */
-	rc = xxsscanf("42", "%1d", &i);
+	rc = sscanf("42", "%1d", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 4);
@@ -450,5 +462,5 @@
 
 	/* Integer with hex prefix, format with limited, sufficient width */
-	rc = xxsscanf("0x1", "%3i", &i);
+	rc = sscanf("0x1", "%3i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 1);
@@ -461,5 +473,5 @@
 
 	/* Integer with hex prefix, format with limited, smaller width */
-	rc = xxsscanf("0x1", "%2i", &i);
+	rc = sscanf("0x1", "%2i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 0);
@@ -472,5 +484,5 @@
 
 	/* Integer with octal prefix, format with limited, sufficient width */
-	rc = xxsscanf("012", "%3i", &i);
+	rc = sscanf("012", "%3i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 012);
@@ -483,5 +495,5 @@
 
 	/* Integer with octal prefix, format with limited, smaller width */
-	rc = xxsscanf("012", "%2i", &i);
+	rc = sscanf("012", "%2i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 01);
@@ -494,5 +506,5 @@
 
 	/* Integer with octal prefix, format with width allowing just for 0 */
-	rc = xxsscanf("012", "%1i", &i);
+	rc = sscanf("012", "%1i", &i);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(i == 0);
@@ -505,7 +517,7 @@
 
 	/* Pointer */
-	rc = xxsscanf("0x12341234", "%p", &ptr);
-	PCUT_ASSERT_INT_EQUALS(1, rc);
-	PCUT_ASSERT_TRUE(ptr == (void *)0x12341234);
+	rc = sscanf("0xABCDEF88", "%p", &ptr);
+	PCUT_ASSERT_INT_EQUALS(1, rc);
+	PCUT_ASSERT_TRUE(ptr == (void *)0xABCDEF88);
 }
 
@@ -516,5 +528,5 @@
 
 	/* Single character */
-	rc = xxsscanf("x", "%c", &c);
+	rc = sscanf("x", "%c", &c);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(c == 'x');
@@ -527,5 +539,5 @@
 
 	/* Single whitespace character */
-	rc = xxsscanf("\t", "%c", &c);
+	rc = sscanf("\t", "%c", &c);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(c == '\t');
@@ -539,5 +551,5 @@
 	/* Multiple characters */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abc", "%3c", chars);
+	rc = sscanf("abc", "%3c", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -554,5 +566,5 @@
 	/* Fewer characters than requested */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abc", "%5c", chars);
+	rc = sscanf("abc", "%5c", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -569,5 +581,5 @@
 	/* Reading characters but no found */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("", "%5c", chars);
+	rc = sscanf("", "%5c", chars);
 	PCUT_ASSERT_INT_EQUALS(EOF, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'X');
@@ -580,5 +592,5 @@
 
 	/* Multiple characters with suppressed assignment */
-	rc = xxsscanf("abc", "%*3c%n", &n);
+	rc = sscanf("abc", "%*3c%n", &n);
 	PCUT_ASSERT_INT_EQUALS(0, rc);
 	PCUT_ASSERT_INT_EQUALS(3, n);
@@ -592,5 +604,5 @@
 	/* Multiple characters with memory allocation */
 	cp = NULL;
-	rc = xxsscanf("abc", "%m3c", &cp);
+	rc = sscanf("abc", "%m3c", &cp);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_NOT_NULL(cp);
@@ -608,5 +620,5 @@
 	/* String of non-whitespace characters, unlimited width */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf(" abc d", "%s", chars);
+	rc = sscanf(" abc d", "%s", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -624,5 +636,5 @@
 	/* String of non-whitespace characters, until the end */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf(" abc", "%s", chars);
+	rc = sscanf(" abc", "%s", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -640,5 +652,5 @@
 	/* String of non-whitespace characters, large enough width */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf(" abc d", "%5s", chars);
+	rc = sscanf(" abc d", "%5s", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -656,5 +668,5 @@
 	/* Want string of non-whitespace, but got only whitespace */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf(" ", "%s", chars);
+	rc = sscanf(" ", "%s", chars);
 	PCUT_ASSERT_INT_EQUALS(EOF, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'X');
@@ -668,5 +680,5 @@
 	/* String of non-whitespace characters, small width */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf(" abc", "%2s", chars);
+	rc = sscanf(" abc", "%2s", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -682,5 +694,5 @@
 
 	/* String of non-whitespace characters, assignment suppression */
-	rc = xxsscanf(" abc d", "%*s%n", &n);
+	rc = sscanf(" abc d", "%*s%n", &n);
 	PCUT_ASSERT_INT_EQUALS(0, rc);
 	PCUT_ASSERT_INT_EQUALS(4, n);
@@ -693,5 +705,5 @@
 
 	/* String of non-whitespace characters, memory allocation */
-	rc = xxsscanf(" abc d", "%ms", &cp);
+	rc = sscanf(" abc d", "%ms", &cp);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_NOT_NULL(cp);
@@ -711,5 +723,5 @@
 	/* Set conversion without width specified terminating before the end  */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abcd42", "%[abc]d%d", chars, &i);
+	rc = sscanf("abcd42", "%[abc]d%d", chars, &i);
 	PCUT_ASSERT_INT_EQUALS(2, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -728,5 +740,5 @@
 	/* Set conversion without width specified, until the end */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abc", "%[abc]", chars);
+	rc = sscanf("abc", "%[abc]", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -744,5 +756,5 @@
 	/* Set conversion with larger width */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abcd", "%5[abc]", chars);
+	rc = sscanf("abcd", "%5[abc]", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -760,5 +772,5 @@
 	/* Set conversion with smaller width */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abcd", "%3[abcd]", chars);
+	rc = sscanf("abcd", "%3[abcd]", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -776,5 +788,5 @@
 	/* Set conversion with negated scanset */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abcd", "%[^d]", chars);
+	rc = sscanf("abcd", "%[^d]", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -792,5 +804,5 @@
 	/* Set conversion with ']' in scanset */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("]bcd", "%[]bc]", chars);
+	rc = sscanf("]bcd", "%[]bc]", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == ']');
@@ -808,5 +820,5 @@
 	/* Set conversion with ']' in inverted scanset */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abc]", "%[^]def]", chars);
+	rc = sscanf("abc]", "%[^]def]", chars);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -823,5 +835,5 @@
 
 	/* Set conversion with assignment suppression */
-	rc = xxsscanf("abcd42", "%*[abc]%n", &n);
+	rc = sscanf("abcd42", "%*[abc]%n", &n);
 	PCUT_ASSERT_INT_EQUALS(0, rc);
 	PCUT_ASSERT_INT_EQUALS(3, n);
@@ -835,5 +847,5 @@
 	/* Set conversion with memory allocation */
 	cp = NULL;
-	rc = xxsscanf("abcd42", "%m[abcd]", &cp);
+	rc = sscanf("abcd42", "%m[abcd]", &cp);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_NOT_NULL(cp);
@@ -852,5 +864,5 @@
 
 	/* Decimal integer with suppressed assignment */
-	rc = xxsscanf("42", "%*d%n", &n);
+	rc = sscanf("42", "%*d%n", &n);
 	PCUT_ASSERT_INT_EQUALS(0, rc);
 	PCUT_ASSERT_INT_EQUALS(2, n);
@@ -865,5 +877,5 @@
 	/* Count of characters read */
 	memset(chars, 'X', chars_size);
-	rc = xxsscanf("abcd", "%3c%n", chars, &n);
+	rc = sscanf("abcd", "%3c%n", chars, &n);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(chars[0] == 'a');
@@ -880,5 +892,5 @@
 
 	/* Float with just integer part */
-	rc = xxsscanf("42", "%f", &f);
+	rc = sscanf("42", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 42.0);
@@ -891,5 +903,5 @@
 
 	/* Double with just integer part */
-	rc = xxsscanf("42", "%lf", &d);
+	rc = sscanf("42", "%lf", &d);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(d == 42.0);
@@ -902,5 +914,5 @@
 
 	/* Long double with just integer part */
-	rc = xxsscanf("42", "%Lf", &ld);
+	rc = sscanf("42", "%Lf", &ld);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(ld == 42.0);
@@ -913,5 +925,5 @@
 
 	/* Float with just hexadecimal integer part */
-	rc = xxsscanf("0x2a", "%f", &f);
+	rc = sscanf("0x2a", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 0x2a.0p0);
@@ -924,5 +936,5 @@
 
 	/* Float with sign and integer part */
-	rc = xxsscanf("-42", "%f", &f);
+	rc = sscanf("-42", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == -42.0);
@@ -935,5 +947,5 @@
 
 	/* Float with integer and fractional part */
-	rc = xxsscanf("4.2", "%f", &f);
+	rc = sscanf("4.2", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	/* 1/10 is not exactly representable in binary floating point */
@@ -948,5 +960,5 @@
 
 	/* Float with integer part and unsigned exponent */
-	rc = xxsscanf("42e1", "%f", &f);
+	rc = sscanf("42e1", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -959,5 +971,5 @@
 
 	/* Float with integer part and positive exponent */
-	rc = xxsscanf("42e+1", "%f", &f);
+	rc = sscanf("42e+1", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -970,5 +982,5 @@
 
 	/* Float with integer part and negative exponent */
-	rc = xxsscanf("42e-1", "%f", &f);
+	rc = sscanf("42e-1", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	/* 1/10 is not exactly representable in binary floating point */
@@ -983,5 +995,5 @@
 
 	/* Float with integer, fractional parts and unsigned exponent */
-	rc = xxsscanf("4.2e1", "%f", &f);
+	rc = sscanf("4.2e1", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 42.0);
@@ -994,5 +1006,5 @@
 
 	/* Hexadecimal float with integer and fractional part */
-	rc = xxsscanf("0x2.a", "%f", &f);
+	rc = sscanf("0x2.a", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 0x2.ap0);
@@ -1007,5 +1019,5 @@
 	 * Hexadecimal float with integer part and unsigned exponent
 	 */
-	rc = xxsscanf("0x2ap1", "%f", &f);
+	rc = sscanf("0x2ap1", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 0x2ap1);
@@ -1020,5 +1032,5 @@
 	 * Hexadecimal float with integer part and negative exponent
 	 */
-	rc = xxsscanf("0x2ap-1", "%f", &f);
+	rc = sscanf("0x2ap-1", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 0x2ap-1);
@@ -1034,5 +1046,5 @@
 	 * exponent
 	 */
-	rc = xxsscanf("0x2.ap4", "%f", &f);
+	rc = sscanf("0x2.ap4", "%f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 0x2.ap4);
@@ -1045,5 +1057,5 @@
 
 	/* Float with just integer part and limited width */
-	rc = xxsscanf("1234", "%3f", &f);
+	rc = sscanf("1234", "%3f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 123.0);
@@ -1056,5 +1068,5 @@
 
 	/* Float with integer, fractional part and limited width */
-	rc = xxsscanf("12.34", "%4f", &f);
+	rc = sscanf("12.34", "%4f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	/* 1/10 is not exactly representable in binary floating point */
@@ -1069,5 +1081,5 @@
 
 	/* Float with width only enough to cover an integral part */
-	rc = xxsscanf("12.34", "%3f", &f);
+	rc = sscanf("12.34", "%3f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 12.0);
@@ -1080,5 +1092,5 @@
 
 	/* Float with width too small to cover the exponent number */
-	rc = xxsscanf("12.34e+2", "%7f", &f);
+	rc = sscanf("12.34e+2", "%7f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	/* 1/10 is not exactly representable in binary floating point */
@@ -1093,5 +1105,5 @@
 
 	/* Float with width too small to cover the exponent sign and number */
-	rc = xxsscanf("12.34e+2", "%6f", &f);
+	rc = sscanf("12.34e+2", "%6f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	/* 1/10 is not exactly representable in binary floating point */
@@ -1106,5 +1118,5 @@
 
 	/* Float with width too small to cover the exponent part */
-	rc = xxsscanf("12.34e+2", "%5f", &f);
+	rc = sscanf("12.34e+2", "%5f", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	/* 1/10 is not exactly representable in binary floating point */
@@ -1119,5 +1131,5 @@
 
 	/* Float using alternate form 'F' */
-	rc = xxsscanf("42e1", "%F", &f);
+	rc = sscanf("42e1", "%F", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -1130,5 +1142,5 @@
 
 	/* Float using alternate form 'a' */
-	rc = xxsscanf("42e1", "%a", &f);
+	rc = sscanf("42e1", "%a", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -1141,5 +1153,5 @@
 
 	/* Float using alternate form 'e' */
-	rc = xxsscanf("42e1", "%e", &f);
+	rc = sscanf("42e1", "%e", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -1152,5 +1164,5 @@
 
 	/* Float using alternate form 'g' */
-	rc = xxsscanf("42e1", "%g", &f);
+	rc = sscanf("42e1", "%g", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -1163,5 +1175,5 @@
 
 	/* Float using alternate form 'A' */
-	rc = xxsscanf("42e1", "%A", &f);
+	rc = sscanf("42e1", "%A", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -1174,5 +1186,5 @@
 
 	/* Float using alternate form 'E' */
-	rc = xxsscanf("42e1", "%E", &f);
+	rc = sscanf("42e1", "%E", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);
@@ -1185,5 +1197,5 @@
 
 	/* Float using alternate form 'G' */
-	rc = xxsscanf("42e1", "%G", &f);
+	rc = sscanf("42e1", "%G", &f);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_TRUE(f == 420.0);